############################################################################
#
# File Name: 		Collection.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Collection.py.html
#

"""
Base class for all collections
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods import PersistentObject

from Ft.Ods.StorageManager.Adapters import Constants

class Collection(PersistentObject.PersistentObject):

    def __init__(self):
        PersistentObject.PersistentObject.__init__(self)
        self.__dict__['_cid'] = 0

    def _4ods_getPersistentType(self):
        return Constants.ObjectTypes.COLLECTION

    def _4ods_getId(self):
        return self.__dict__['_cid']

    def _4ods_getCid(self):
        return self.__dict__['_cid']

    def _4ods_setCid(self,cid):
        self.__dict__['_cid'] = cid
    
    relationships = ()
    readOnlyAttributes = ()
    readWriteAttributes = ()
    _collections = ()
    collectionMap = {}
    _extents = ()
    localExtents = ()

    def _4ods_getContents(self):
        raise "Override Please"
