############################################################################
#
# File Name: 		Bag.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Bag.py.html
#
"""
Bag: pretty much just a collection.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.Collections import CollectionBase

from Ft.Ods.StorageManager.Adapters import Constants


class BagBase(CollectionBase.CollectionBase):
    def __init__(self):
        self._kind = 'Bag'

    def is_ordered(self):
        return 0

    def allows_duplicates(self):
        return 1


    def occurrences_of(self, element):
        return self._4ods_countOccurrences(element)

    def create_union(self, other_bag):
        #NOTE should we trim duplicates?
        result = self.copy(deep=0)
        other_py_list = other_bag._4ods_getContents()
        for item in other_py_list:
            if self.contains_element(item):
                result.insert_element(item)
        return result

    def create_intersection(self, other_bag):
        #NOTE should we trim duplicates?
        result = self.copy(deep=0)
        result_list = list(other_bag._4ods_getContents())
        for item in self._4ods_getContents():
            if not item in result_list:
                result_list.append(item)
        result._4ods_initialize(len(result_list),self._4ods_getSubType(),result_list)
        return result

    def create_difference(self, other_bag):
        #NOTE should we trim duplicates?
        result_list = []
        result = self.copy(deep=0)

        for item in other_bag._4ods_getContents():
            if not self.contains_element(item):
                result_list.append(item)
        for item in self._4ods_getContents():
            if not other_bag.contains_element(item):
                result_list.append(item)
        result._4ods_initialize(len(result_list),self._4ods_getSubType(),result_list)
        return result

    collectionType = Constants.CollectionTypes.BAG
