############################################################################
#
# File Name: 		CollectionOfPersistentObjects.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/CollectionOfPersistentObjects.py.html
#
"""
Base class for all lists of persistent objects
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

import types

from Ft.Ods import Database

from Ft.Ods.Collections import CollectionOfValues

class CollectionOfPersistentObjects(CollectionOfValues.CollectionOfValues):

    def __init__(self,_type):
        CollectionOfValues.CollectionOfValues.__init__(self)
        self.__dict__['_type'] = _type
        if type(self.__dict__['_type']) != type(1):
            raise "Dumb Ass"

	self.__objects = {}


    def _4ods_objectExternalPrepare(self,oid):
        if type(oid) == types.InstanceType:
            return oid
	if self.__objects.has_key(oid):
            return self.__objects[oid]
        rt = self.__dict__['_db']._4ods_getPersistentObjectById(self.__dict__['_type'],int(oid))
	self.__objects[oid] = rt
	return rt

    def _4ods_objectInternalPrepare(self,obj):
        if type(obj) == types.InstanceType:
            return obj._4ods_getId()
        return obj
