########################################################################
#
# File Name: 	       Attribute.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Attribute.py.html
#
"""
Implements the Attribute meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import Property
from Ft.Ods.MetaData import RepositoryObject

from Ft.Ods.StorageManager.Adapters import Constants

class Attribute(Property.Property):
    def __init__(self):
        self.__dict__['is_read_only'] = 0
        Property.Property.__init__(self, RepositoryObject.MetaKind.mk_attribute)


    def _4ods_getOdl(self):
        ro = ''
        if self.is_read_only:
            ro = 'readonly '
        if self.type.meta_kind == RepositoryObject.MetaKind.mk_collection:
            return '%sattribute %s <%s> %s;'  % (ro,self.type._4ods_getOdl(),self.type.subtype.absolute_name(),self.name)
        else:
            return '%sattribute %s %s;' % (ro,self.type.absolute_name(),self.name)




    readOnlyAttributes = Property.Property.readOnlyAttributes
    readWriteAttributes = Property.Property.readWriteAttributes + ('is_read_only',)
    relationships = Property.Property.relationships


    tupleNames =  Property.Property.tupleNames  + ('is_read_only',
                                                   )
    tupleTypes =  Property.Property.tupleTypes + (Constants.Types.BOOLEAN,
                                                  )

    _collections = Property.Property._collections
    collectionMap = Property.Property.collectionMap.copy()

    localExtents = ()
