########################################################################
#
# File Name: 	        ConstOperand.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/ConstOperand.py.html
#
"""
Implements the ConstOperand meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Operand
from Ft.Ods.MetaData import RepositoryObject

from Ft.Ods.StorageManager.Adapters import Constants

class ConstOperand(Operand.Operand):
    def __init__(self):
        Operand.Operand.__init__(self,RepositoryObject.MetaKind.mk_const_operand)


    def __getattr__(self,name):
        if name == 'references':
            return self.__dict__['_references']
        else:
            return Operand.Operand.__getattr__(self,name)

    def value(self):
        if self._references:
            return self._references.value()
        return None

    def form_references(self,target,inverse = 1):
        from Ft.Ods.MetaData import Constant
        self._4ods_formRelationship('_references',Constant.Constant,'referenced_by','add',target,inverse)
    def drop_references(self,target,inverse = 1):
        self._4ods_dropRelationship('_references','referenced_by','remove',target,inverse)


    def _4ods_getOdl(self):
        return self.__dict__['_references'].name

    readOnlyAttributes = Operand.Operand.readOnlyAttributes + ('_references',)
    readWriteAttributes = Operand.Operand.readWriteAttributes
    relationships = Operand.Operand.relationships + ('_references',)

    tupleNames =  Operand.Operand.tupleNames + ('_references',
                                                                  )
    tupleTypes =  Operand.Operand.tupleTypes + (Constants.Types.OBJECT,
                                                    )

    localExtents = ()
    _collections = Operand.Operand._collections
    collectionMap = Operand.Operand.collectionMap.copy()


