########################################################################
#
# File Name: 	       Dictionary.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Dictionary.py.html
#
"""
Implements the Dictionary meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought, Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import Collection
from Ft.Ods.StorageManager.Adapters import Constants

class Dictionary(Collection.Collection):

    def __init__(self):
        Collection.Collection.__init__(self,collection_kind=Collection.CollectionKind.ck_dictionary)

    def form_key_type(self,target,inverse = 1):
        from Ft.Ods.MetaData import Type
        self._4ods_formRelationship('key_type',Type.Type,'dictionaries','add',target,inverse)

    def drop_key_type(self,target,inverse = 1):
        self._4ods_dropRelationship('key_type','dictionaries','remove',target,inverse)


    def _4ods_getOdmgType(self):
        return Constants.Types.DICTIONARY

    readOnlyAttributes = Collection.Collection.readOnlyAttributes + ('key_type',)
    readWriteAttributes = Collection.Collection.readWriteAttributes 
    relationships = Collection.Collection.relationships + ('key_type',)

    tupleNames =  Collection.Collection.tupleNames + ('key_type',
                                                    )
    tupleTypes =  Collection.Collection.tupleTypes + (Constants.Types.OBJECT,
                                                    )

    _collections = Collection.Collection._collections
    collectionMap = Collection.Collection.collectionMap.copy()
    localExtents = ()
