########################################################################
#
# File Name: 	       Exception.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Exception.py.html
#
"""
Implements the Exception meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import MetaObject
from Ft.Ods.MetaData import RepositoryObject
from Ft.Ods.StorageManager.Adapters import Constants

from Ft.Ods.Collections import LiteralSetOfRepositoryObjects

class Exception(MetaObject.MetaObject):

    def __init__(self):
        MetaObject.MetaObject.__init__(self,RepositoryObject.MetaKind.mk_exception)

    def form_result(self,target,inverse = 1):
        from Ft.Ods.MetaData import Structure
        self._4ods_addRelationship('result',Structure.Structure,'exception_result','form',target,inverse)

    def drop_result(self,target,inverse = 1):
        self._4ods_dropRelationship('result','exception_result','drop',target,inverse)


    def form_operations(self,target,inverse = 1):
        self.add_operations(target,inverse)

    def add_operations(self,target,inverse = 1):
        self._4ods_addRelationship('operations',Operation.Operations,'exceptions','add',target,inverse)

    def drop_operations(self,target,inverse = 1):
        self.remove_operations(target,inverse)

    def remove_operations(self,target,inverse = 1):
        seld._4ods_removeRelationship('operations','exceptions','remove',target,inverse)



    readOnlyAttributes = MetaObject.MetaObject.readOnlyAttributes + ('result','operations')
    readWriteAttributes = MetaObject.MetaObject.readWriteAttributes 
    relationships = MetaObject.MetaObject.relationships + ('result','operations')

    tupleNames =  MetaObject.MetaObject.tupleNames + ('result','operations')


    tupleTypes =  MetaObject.MetaObject.tupleTypes + (Constants.Types.OBJECT,
                                                    Constants.Types.OBJECT_SET
                                                    )
        

    _collections = MetaObject.MetaObject._collections + ('operations',)
    collectionMap = MetaObject.MetaObject.collectionMap.copy()
    collectionMap.update({'operations':LiteralSetOfRepositoryObjects.LiteralSetOfRepositoryObjects
                          }
                         )


    localExtents = ()
