########################################################################
#
# File Name: 	        Expression.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Expression.py.html
#
"""
Implements the Expression meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Operand
from Ft.Ods.MetaData import RepositoryObject

from Ft.Ods.StorageManager.Adapters import Constants

from Ft.Ods.Collections import LiteralListOfRepositoryObjects

class Expression(Operand.Operand):
    def __init__(self):
        Operand.Operand.__init__(self,RepositoryObject.MetaKind.mk_expression)
        self.__dict__['operator'] = ''


    def form_the_operands(self,target,inverse = 1):
        self.add_the_operands(target,inverse)

    def add_the_operands(self,target,inverse = 1):
        self._4ods_addRelationship('the_operands',Operand.Operand,'operand_in','form',target,inverse)
    def drop_the_operands(self,target,inverse = 1):
        self.remove_the_operands(target,inverse)
    def remove_the_operands(self,target,inverse = 1):
        self._4ods_removeRelationship('the_operands','operand_in','drop',target,inverse)


    readOnlyAttributes = Operand.Operand.readOnlyAttributes + ('the_operands',)
    readWriteAttributes = Operand.Operand.readWriteAttributes + ('operator',)
    relationships = Operand.Operand.relationships + ('the_operands',)

    tupleNames =  Operand.Operand.tupleNames + ('operator','the_operands')
    tupleTypes =  Operand.Operand.tupleTypes + (Constants.Types.STRING,Constants.Types.OBJECT_LIST
                                                    )


    _collections = Operand.Operand._collections + ('the_operands',)
    collectionMap = Operand.Operand.collectionMap.copy()
    collectionMap.update({'the_operands':LiteralListOfRepositoryObjects.LiteralListOfRepositoryObjects
                          }
                         )

    localExtents = ()
