########################################################################
#
# File Name: 	        Literal.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Literal.py.html
#
"""
Implements the Literal meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Operand
from Ft.Ods.MetaData import RepositoryObject

from Ft.Ods.StorageManager.Adapters import Constants

import cPickle
import types
try:
    g_stringTypes= [types.StringType, types.UnicodeType]
except:
    g_stringTypes= [types.StringType]


class Literal(Operand.Operand):
    def __init__(self):
        Operand.Operand.__init__(self,RepositoryObject.MetaKind.mk_literal)
        self.__dict__['_literal_value'] = cPickle.dumps(None)

    def value(self):
        return cPickle.loads(self.__dict__['_literal_value'])

    def __getattr__(self,name):
        if name == 'literal_value':
            return cPickle.loads(self.__dict__['_literal_value'])
        else:
            return Operand.Operand.__getattr__(self,name)

    def __setattr__(self,name,value):
        if name == 'literal_value':
            self.__dict__['_literal_value'] = cPickle.dumps(value)
            self.__dict__['_modifiedAttrs']['_literal_value'] = 1
        else:
            Operand.Operand.__setattr__(self,name,value)

    def _4ods_getOdl(self):
        lv = self.literal_value
        if type(lv) == type(1):
            return lv
        elif type(lv) == type(1.2):
            return lv
        elif type(lv) in g_stringTypes:
            if len(lv) == 1:
                return "'" + lv + "'"
            return '"' + lv + '"'
        else:
            raise "Need more input"

    readOnlyAttributes = Operand.Operand.readOnlyAttributes + ('_literal_value',)
    readWriteAttributes = Operand.Operand.readWriteAttributes
    relationships = Operand.Operand.relationships

    tupleNames =  Operand.Operand.tupleNames + ('_literal_value',)
    tupleTypes =  Operand.Operand.tupleTypes + (Constants.Types.STRING,)

    _collections = Operand.Operand._collections
    collectionMap = Operand.Operand.collectionMap


    localExtents = ()
