########################################################################
#
# File Name: 	        Member.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Member.py.html
#
"""
Implements the Member meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Specifier
from Ft.Ods.MetaData import RepositoryObject

from Ft.Ods.StorageManager.Adapters import Constants

class Member(Specifier.Specifier):
    def __init__(self):
        Specifier.Specifier.__init__(self,RepositoryObject.MetaKind.mk_member)

    def form_structure_type(self,target,inverse = 1):
        from Ft.Ods.MetaData import Structure
        self._4ods_formRelationship('structure_type',Structure.Structure,'fields','add',target,inverse)
    def drop_structure_type(self,target,inverse = 1):
        self._4ods_dropRelationship('structure_type','fields','remove',target,inverse)


    readOnlyAttributes = Specifier.Specifier.readOnlyAttributes + ('structure_type',)
    readWriteAttributes = Specifier.Specifier.readWriteAttributes
    relationships = Specifier.Specifier.relationships + ('structure_type',)

    tupleNames =  Specifier.Specifier.tupleNames + ('structure_type',
                                                                  )
    tupleTypes =  Specifier.Specifier.tupleTypes + (Constants.Types.OBJECT,
                                                    )

    _collections = Specifier.Specifier._collections
    collectionMap = Specifier.Specifier.collectionMap

    localExtents = ()
