########################################################################
#
# File Name: 	       Property.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Property.py.html
#
"""
Implements the Property meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import MetaObject

from Ft.Ods.MetaData import Type

from Ft.Ods.StorageManager.Adapters import Constants


#ftods_attributes = ['']

class Property(MetaObject.MetaObject):
    def __init__(self, meta_kind):
        MetaObject.MetaObject.__init__(self, meta_kind)


    def form_type(self,target,inverse=1):
        self._4ods_formRelationship('type',Type.Type,'properties','add',target,inverse)

    def drop_type(self,target,inverse=1):
        self._4ods_dropRelationship('type','properties','remove',target,inverse)

      
    def _4ods_getOdmgType(self):
        return self.type._4ods_getOdmgType()

    readOnlyAttributes = MetaObject.MetaObject.readOnlyAttributes + ('type',)
    readWriteAttributes = MetaObject.MetaObject.readWriteAttributes
    relationships = MetaObject.MetaObject.relationships + ('type',)

    tupleNames = MetaObject.MetaObject.tupleNames + ('type',
                                                     )
    tupleTypes = MetaObject.MetaObject.tupleTypes + (Constants.Types.OBJECT,
                                                     )

    _collections = MetaObject.MetaObject._collections
    collectionMap = MetaObject.MetaObject.collectionMap
    localExtents = ()
