########################################################################
#
# File Name: 	        Specifier.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Specifier.py.html
#
"""
Implements the Specifier meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import RepositoryObject
from Ft.Ods.StorageManager.Adapters import Constants

class Specifier(RepositoryObject.RepositoryObject):
    def __init__(self,metaKind):
        RepositoryObject.RepositoryObject.__init__(self,metaKind)

        self.__dict__['name'] = ''


    def form_type(self,target,inverse = 1):
        from Ft.Ods.MetaData import Type
        self._4ods_formRelationship('type',Type.Type,'specifiers','add',target,inverse)

    def drop_type(self,target,inverse = 1):
        self._4ods_dropRelationship('type','specifiers','remove',target,inverse)


    readOnlyAttributes = RepositoryObject.RepositoryObject.readOnlyAttributes + ('type',)
    readWriteAttributes = RepositoryObject.RepositoryObject.readWriteAttributes  + ('name',)
    relationships = RepositoryObject.RepositoryObject.relationships + ('type',)

    tupleNames =  RepositoryObject.RepositoryObject.tupleNames + ('name','type'
                                                                  )
    tupleTypes =  RepositoryObject.RepositoryObject.tupleTypes + (Constants.Types.STRING,
                                                      Constants.Types.OBJECT
                                                    )


    _collections = RepositoryObject.RepositoryObject._collections
    collectionMap = RepositoryObject.RepositoryObject.collectionMap


    localExtents = ()
