########################################################################
#
# File Name: 	        TypeDefinition.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/TypeDefinition.py.html
#
"""
Implements the TypeDefinition meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Type

from Ft.Ods.MetaData import RepositoryObject
from Ft.Ods.StorageManager.Adapters import Constants

class TypeDefinition(Type.Type):
    def __init__(self):
        Type.Type.__init__(self,RepositoryObject.MetaKind.mk_type_definition)


    def form_alias(self,target,inverse = 1):
        self._4ods_formRelationship('alias',Type.Type,'type_defs','add',target,inverse)

    def drop_alias(self,target,inverse = 1):
        self._4ods_dropRelationship('alias','type_defs','remove',target,inverse)


    readOnlyAttributes = Type.Type.readOnlyAttributes + ('alias',)
    readWriteAttributes = Type.Type.readWriteAttributes
    relationships = Type.Type.relationships

    tupleNames = Type.Type.tupleNames + ('alias',)
    tupleTypes = Type.Type.tupleTypes + (Constants.Types.OBJECT,)


    _collections = Type.Type._collections
    collectionMap = Type.Type.collectionMap
    localExtents = ()
