########################################################################
#
# File Name: 	        Union.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Union.py.html
#
"""
Implements the Union meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import ScopedType
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.MetaData import UnionCase
from Ft.Ods.Collections import LiteralListOfRepositoryObjects
from Ft.Ods.MetaData import RepositoryObject

class Union(ScopedType.ScopedType):
    def __init__(self):
        ScopedType.ScopedType.__init__(self,RepositoryObject.MetaKind.mk_union)

    def form_switch_type(self,target,inverse = 1):
        from ft.Ods.MetaData import Type
        self._4ods_formRelationship('switch_type',Type.Type,'unions','add',target,inverse)

    def drop_switch_type(self,target,inverse = 1):
        self._4ods_dropRelationship('switch_type','unions','remove',target,inverse)

    def form_cases(self,target,inverse = 1):
        self.add_cases(target,inverse)
    def add_cases(self,target,inverse = 1):
        self._4ods_addRelationship('cases',UnionCase.UnionCase,'union_type','form',target,inverse)
    def drop_cases(self,target,inverse = 1):
        self.remove_cases(target,inverse = 1)
    def remove_cases(self,target,inverse = 1):
        self._4ods_removeRelationship('cases','union_type','drop',target,inverse)



    def _4ods_getOdl(self):
        pass



        
    readOnlyAttributes = ScopedType.ScopedType.readOnlyAttributes + ('cases','switch_type')
    readWriteAttributes = ScopedType.ScopedType.readWriteAttributes 
    relationships = ScopedType.ScopedType.relationships + ('cases','switch_type')

    tupleNames =  ScopedType.ScopedType.tupleNames + ('cases','switch_type'
                                                    )
    tupleTypes =  ScopedType.ScopedType.tupleTypes + (Constants.Types.OBJECT_LIST,
                                                      Constants.Types.OBJECT
                                                    )

    _collections = ScopedType.ScopedType._collections + ('cases',)
    collectionMap = ScopedType.ScopedType.collectionMap.copy()
    collectionMap.update({'cases':LiteralListOfRepositoryObjects.LiteralListOfRepositoryObjects
                          }
                         )
    


    localExtents = ()
