########################################################################
#
# File Name: 	        PostgresMappings.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Drivers/PostgresMappings.py.html
#
"""
The Postgres Mappings for the backend
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought, Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.StorageManager.Adapters import Constants

g_odmgToSqlTypes = {
    Constants.Types.BOOLEAN: 'NUMBER(1,0)',
    Constants.Types.BOOLEAN_BAG: 'NUMBER(30,0)',
    Constants.Types.BOOLEAN_SET: 'NUMBER(30,0)',
    Constants.Types.BOOLEAN_LIST: 'NUMBER(30,0)',
    Constants.Types.SIGNED_SHORT: 'NUMBER(15,0)',
    Constants.Types.SIGNED_SHORT_BAG: 'NUMBER(30,0)',
    Constants.Types.SIGNED_SHORT_LIST: 'NUMBER(30,0)',
    Constants.Types.SIGNED_SHORT_SET: 'NUMBER(30,0)',
    Constants.Types.STRING: 'VARCHAR(2048)',
    Constants.Types.STRING_BAG: 'NUMBER(30,0)',
    Constants.Types.STRING_SET: 'NUMBER(30,0)',
    Constants.Types.STRING_LIST: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_SHORT: 'NUMBER(15,0)',
    Constants.Types.UNSIGNED_SHORT_BAG: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_SHORT_SET: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_SHORT_LIST: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_BAG: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_SET: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_LIST: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_LONG: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_LONG_BAG: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_LONG_SET: 'NUMBER(30,0)',
    Constants.Types.UNSIGNED_LONG_LIST: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_LONG: 'NUMERIC(40,0)',
    Constants.Types.SIGNED_LONG_LONG_BAG: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_LONG_SET: 'NUMBER(30,0)',
    Constants.Types.SIGNED_LONG_LONG_LIST: 'NUMBER(30,0)',
    Constants.Types.FLOAT: 'NUMBER(15,7)',
    Constants.Types.FLOAT_BAG: 'NUMBER(30,0)',
    Constants.Types.FLOAT_SET: 'NUMBER(30,0)',
    Constants.Types.FLOAT_LIST: 'NUMBER(30,0)',
    Constants.Types.DOUBLE: 'NUMBER(30,15)',
    Constants.Types.DOUBLE_BAG: 'NUMBER(30,0)',
    Constants.Types.DOUBLE_SET: 'NUMBER(30,0)',
    Constants.Types.DOUBLE_LIST: 'NUMBER(30,0)',
    Constants.Types.OBJECT: 'NUMBER(30,0)',
    Constants.Types.OBJECT_BAG: 'NUMBER(30,0)',
    Constants.Types.OBJECT_SET: 'NUMBER(30,0)',
    Constants.Types.OBJECT_LIST: 'NUMBER(30,0)',
    Constants.Types.ENUMERATION: 'NUMBER(15,0)',
    Constants.Types.STRUCTURE: 'NUMBER(30,0)',
    Constants.Types.DICTIONARY:'NUMBER(30,0)',
    Constants.Types.FILE:'VARCHAR(1024)',

}

g_collectionTableMapping = {
    Constants.Types.STRING : {Constants.CollectionTypes.LIST:'ftods_string_list',
                              Constants.CollectionTypes.BAG:'ftods_string_bag',
                              Constants.CollectionTypes.SET:'ftods_string_set',
                              },
    Constants.Types.OBJECT: {Constants.CollectionTypes.BAG:'ftods_long_bag',
                             Constants.CollectionTypes.SET:'ftods_long_set',
                             Constants.CollectionTypes.LIST: 'ftods_long_list'
                             },

    Constants.Types.SIGNED_SHORT: {Constants.CollectionTypes.BAG: 'ftods_long_bag',
                                     Constants.CollectionTypes.SET: 'ftods_long_set',
                                     Constants.CollectionTypes.LIST: 'ftods_long_list'
                                     },

    Constants.Types.DOUBLE : {Constants.CollectionTypes.BAG: 'ftods_double_bag',
                              Constants.CollectionTypes.SET: 'ftods_double_set',
                              Constants.CollectionTypes.LIST: 'ftods_double_list',
                              },

    }


    #Constants.Types.BOOLEAN_BAG: 'ftods_boolean_bag',
    #Constants.Types.BOOLEAN_SET: 'ftods_boolean_set',
    #Constants.Types.BOOLEAN_LIST: 'ftods_boolean_list',
    #Constants.Types.SIGNED_SHORT_BAG: 'ftods_long_bag',
    #Constants.Types.SIGNED_SHORT_LIST: 'ftods_long_list',
    #Constants.Types.SIGNED_SHORT_SET: 'ftods_long_set',
    #Constants.Types.STRING_BAG: 'ftods_string_bag',
    #Constants.Types.STRING_SET: 'ftods_string_set',
    #Constants.Types.STRING_LIST: 'ftods_string_list',
    #Constants.Types.SIGNED_LONG_BAG: 'ftods_long_bag',
    #Constants.Types.SIGNED_LONG_SET: 'ftods_long_set',
    #Constants.Types.SIGNED_LONG_LIST: 'ftods_long_list',
    #Constants.Types.UNSIGNED_LONG_BAG: 'ftods_long_bag',
    #Constants.Types.UNSIGNED_LONG_SET: 'ftods_long_list',
    #Constants.Types.UNSIGNED_LONG_LIST: 'ftods_long_list',
    #Constants.Types.SIGNED_LONG_LONG_BAG: 'ftods_longlong_bag',
    #Constants.Types.SIGNED_LONG_LONG_SET: 'ftods_longlong_set',
    #Constants.Types.SIGNED_LONG_LONG_LIST: 'ftods_longlong_list',
    #Constants.Types.DOUBLE_BAG: 'ftods_double_bag',
    #Constants.Types.DOUBLE_SET: 'ftods_double_set',
    #Constants.Types.DOUBLE_LIST: 'ftods_double_list',
    #}

g_metaKindToTableName = {0:'ftods_attribute',
                         1:'ftods_class',
                         2:'ftods_metadatacollection',
                         3:'ftods_constant',
                         4:'ftods_const_operand',
                         5:'ftods_enumeration',
                         6:'ftods_exception',
                         7:'ftods_expression',
                         8:'ftods_interface',
                         9:'ftods_metadataliteral',
                         10:'ftods_member',
                         11:'ftods_module',
                         12:'ftods_operation',
                         13:'ftods_parameter',
                         14:'ftods_primitive_type',
                         15:'ftods_relationship',
                         16:'ftods_module',
                         17:'ftods_structure',
                         18:'ftods_type_definition',
                         19:'ftods_union',
                         20:'ftods_union_case'
                         }

g_metaKindToRepoClass = {}

class SystemTypes:
    NAME=1
    OBJECT=2
    ENUMERATION = 3
    STRING = 4
    BOOLEAN = 5
    SHORT = 6

g_systemTypesToSql = {SystemTypes.NAME:"VARCHAR(128)",
                      SystemTypes.OBJECT:g_odmgToSqlTypes[Constants.Types.OBJECT],
                      SystemTypes.ENUMERATION:g_odmgToSqlTypes[Constants.Types.ENUMERATION],
                      SystemTypes.STRING:g_odmgToSqlTypes[Constants.Types.STRING],
                      SystemTypes.BOOLEAN:g_odmgToSqlTypes[Constants.Types.BOOLEAN],
                      SystemTypes.SHORT:g_odmgToSqlTypes[Constants.Types.UNSIGNED_SHORT],
                      }

SYSTEM_ACCESS = 1
OBJECT_ACCESS = 2
METADATA_ACCESS = 3

TABLE_INIT = 1
TABLE_ACCESS = 2
TABLE_INHERITS = 3

#A list of all of the table names in creation order
g_sortedTableNames = ['ftods_binding',
                      'ftods_extents',
                      'ftods_extenttables',
                      'ftods_extentmapping',
                      'ftods_metaname',
                      'ftods_pythonclass',
                      'ftods_actualclass',
                      'ftods_collectionclass',
                      'ftods_object',
                      'ftods_collection',
                      'ftods_literal',
                      'ftods_repomap',
                      'ftods_repositoryobject',
                      'ftods_metaobject',
                      'ftods_definingscope',
                      'ftods_module',
                      'ftods_operation',
                      'ftods_exception',
                      'ftods_constant',
                      'ftods_property',
                      'ftods_attribute',
                      'ftods_relationship',
                      'ftods_type',
                      'ftods_typedef',
                      'ftods_primitive_type',
                      'ftods_interface',
                      'ftods_class',
                      'ftods_metadatacollection',
                      'ftods_dictionary',
                      'ftods_enumeration',
                      'ftods_structure',
                      'ftods_union',
                      'ftods_specifier',
                      'ftods_member',
                      'ftods_unioncase',
                      'ftods_parameter',
                      'ftods_operand',
                      'ftods_metadataliteral',
                      'ftods_const_operand',
                      'ftods_expression',                      
                      ]
                      
g_tables = {
    'ftods_binding' : {TABLE_INIT:[('name',SystemTypes.NAME,'PRIMARY KEY'),
                                   ('objid',SystemTypes.OBJECT,''),
                                   ('repoid',SystemTypes.OBJECT,'')
                                   ],
                       TABLE_ACCESS:OBJECT_ACCESS,
                       TABLE_INHERITS:""
                       },
    'ftods_extents': {TABLE_INIT:[('name',SystemTypes.NAME,'PRIMARY KEY'),
                                  ('extentid',SystemTypes.OBJECT,''),
                                  ('persistentType',SystemTypes.ENUMERATION,'')
                                  ],
                      TABLE_ACCESS:SYSTEM_ACCESS,
                      TABLE_INHERITS:""
                      },
                      

    'ftods_extenttables': {TABLE_INIT:[('extentid',SystemTypes.OBJECT,''),
                                       ('tablename',SystemTypes.NAME,'')
                                       ],
                           TABLE_ACCESS:SYSTEM_ACCESS,
                           TABLE_INHERITS:""
                           },
                           
    'ftods_extentmapping': {TABLE_INIT:[('extentid',SystemTypes.OBJECT,''),
                                        ('id',SystemTypes.OBJECT,'')
                                        ],
                            TABLE_ACCESS:SYSTEM_ACCESS,
                            TABLE_INHERITS:""
                            },
    
    'ftods_metaname': {TABLE_INIT:[('repoid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                   ('meta_kind',SystemTypes.NAME,''),
                                   ],
                            TABLE_ACCESS:METADATA_ACCESS,
                            TABLE_INHERITS:""
                            },

    'ftods_pythonclass': {TABLE_INIT:[('pythonClassid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                      ('pythonClassName',SystemTypes.STRING,''),
                                      ],
                            TABLE_ACCESS:OBJECT_ACCESS,
                            TABLE_INHERITS:""
                            },
                          
    'ftods_actualclass':{TABLE_INIT:[('oid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                     ('pythonclassid',SystemTypes.OBJECT,''),
                                     ],
                            TABLE_ACCESS:OBJECT_ACCESS,
                            TABLE_INHERITS:""
                            },
    'ftods_collectionclass':{TABLE_INIT:[('cid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                         ('pythonclassid',SystemTypes.OBJECT,''),
                                         ('subtype',SystemTypes.ENUMERATION,''),
                                     ],
                            TABLE_ACCESS:OBJECT_ACCESS,
                            TABLE_INHERITS:""
                            },
    'ftods_object':{TABLE_INIT:[('oid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                ],
                            TABLE_ACCESS:OBJECT_ACCESS,
                            TABLE_INHERITS:""
                            },
    'ftods_collection':{TABLE_INIT:[('cid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                    ],
                            TABLE_ACCESS:SYSTEM_ACCESS,
                            TABLE_INHERITS:""
                            },
                        
    'ftods_literal':{TABLE_INIT:[('lid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                 ],
                     TABLE_ACCESS:OBJECT_ACCESS,
                     TABLE_INHERITS:""
                     },

    'ftods_repomap':{TABLE_INIT:[('repoid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                 ('meta_kind',SystemTypes.ENUMERATION,''),
                                 ],
                     TABLE_ACCESS:OBJECT_ACCESS,
                     TABLE_INHERITS:""
                     },
    'ftods_repositoryobject':{TABLE_INIT:[('repoid',SystemTypes.OBJECT,'PRIMARY KEY'),
                                          ('meta_kind',SystemTypes.ENUMERATION,''),
                                          ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:""
                     },

    'ftods_metaobject':{TABLE_INIT:[('name',SystemTypes.STRING,''),
                                    ('ods_comment',SystemTypes.STRING,''),
                                    ('definedIn',SystemTypes.OBJECT,''),
                                    ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_repositoryobject"
                     },
                        
    'ftods_definingscope':{TABLE_INIT:[('defines',SystemTypes.OBJECT,''),
                                       ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:""
                     },
    'ftods_module':{TABLE_INIT:[
    ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject,ftods_definingscope"
                     },
    'ftods_operation':{TABLE_INIT:[('signature',SystemTypes.OBJECT,''),
                                   ('result',SystemTypes.OBJECT,''),
                                   ('exceptions',SystemTypes.OBJECT,''),
                                   ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject"
                     },
                       
    'ftods_exception':{TABLE_INIT:[('result',SystemTypes.OBJECT,''),
                                   ('operations',SystemTypes.OBJECT,''),
                                   ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject"
                     },

    'ftods_constant':{TABLE_INIT:[('the_value',SystemTypes.OBJECT,''),
                                  ('type',SystemTypes.OBJECT,''),
                                  ('referenced_by',SystemTypes.OBJECT,''),
                                  ('enumeration',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject"
                     },
                      
    'ftods_property':{TABLE_INIT:[('type',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject"
                     },
                      

    'ftods_attribute':{TABLE_INIT:[('is_read_only',SystemTypes.BOOLEAN,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_property"
                     },
                      
    'ftods_relationship':{TABLE_INIT:[('traversal',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_property"
                     },
                      
    'ftods_type':{TABLE_INIT:[('collections',SystemTypes.OBJECT,''),
                              ('dictionaries',SystemTypes.OBJECT,''),
                              ('specifiers',SystemTypes.OBJECT,''),
                              ('unions',SystemTypes.OBJECT,''),
                              ('operations',SystemTypes.OBJECT,''),
                              ('properties',SystemTypes.OBJECT,''),
                              ('constants',SystemTypes.OBJECT,''),
                              ('type_defs',SystemTypes.OBJECT,''),
                              ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_metaobject"
                     },
                      
    'ftods_typedef':{TABLE_INIT:[('type',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_type"
                     },
                      
    'ftods_primitive_type':{TABLE_INIT:[('primitive_kind',SystemTypes.ENUMERATION,''),
                                  ],
                            TABLE_ACCESS:METADATA_ACCESS,
                            TABLE_INHERITS:"ftods_type"
                            },
                      
    'ftods_interface':{TABLE_INIT:[('inherits',SystemTypes.OBJECT,''),
                                  ('derives',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_type,ftods_definingscope"
                     },
                      
    'ftods_class':{TABLE_INIT:[('extents',SystemTypes.OBJECT,''),
                               ('keys',SystemTypes.OBJECT,''),
                               ('extender',SystemTypes.OBJECT,''),
                               ('extensions',SystemTypes.OBJECT,''),
                                  ],
                   TABLE_ACCESS:METADATA_ACCESS,
                   TABLE_INHERITS:"ftods_interface"
                   },
                      
    'ftods_metadatacollection':{TABLE_INIT:[('collection_kind',SystemTypes.ENUMERATION,''),
                                            ('max_size',SystemTypes.SHORT,''),
                                            ('subtype',SystemTypes.OBJECT,''),
                                            ],
                                TABLE_ACCESS:METADATA_ACCESS,
                                TABLE_INHERITS:"ftods_type"
                                },
                      
    'ftods_dictionary':{TABLE_INIT:[('key_type',SystemTypes.OBJECT,''),
                                    ],
                        TABLE_ACCESS:METADATA_ACCESS,
                        TABLE_INHERITS:"ftods_collection"
                        },
                      
    'ftods_enumeration':{TABLE_INIT:[('elements',SystemTypes.OBJECT,''),
                                     ],
                         TABLE_ACCESS:METADATA_ACCESS,
                         TABLE_INHERITS:"ftods_type"
                         },
                      
    'ftods_structure':{TABLE_INIT:[('fields',SystemTypes.OBJECT,''),
                                  ('exception',SystemTypes.OBJECT,''),
                                  ],
                       TABLE_ACCESS:METADATA_ACCESS,
                       TABLE_INHERITS:"ftods_type"
                       },
                      
    'ftods_union':{TABLE_INIT:[('switch_type',SystemTypes.OBJECT,''),
                               ('cases',SystemTypes.OBJECT,''),
                               ],
                   TABLE_ACCESS:METADATA_ACCESS,
                   TABLE_INHERITS:"ftods_metaobject"
                   },

    'ftods_specifier':{TABLE_INIT:[('name',SystemTypes.STRING,''),
                                   ('type',SystemTypes.OBJECT,''),
                                   ],
                       TABLE_ACCESS:METADATA_ACCESS,
                       TABLE_INHERITS:"ftods_repositoryobject"
                       },
                      
    'ftods_member':{TABLE_INIT:[('strucutre_type',SystemTypes.OBJECT,''),
                                ],
                    TABLE_ACCESS:METADATA_ACCESS,
                    TABLE_INHERITS:"ftods_specifier"
                    },
    'ftods_unioncase':{TABLE_INIT:[('ods_union',SystemTypes.OBJECT,''),
                                  ('caselabels',SystemTypes.OBJECT,''),
                                   ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_specifier"
                     },
                      
    'ftods_parameter':{TABLE_INIT:[('parametermode',SystemTypes.ENUMERATION,''),
                                  ('operations',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_specifier"
                     },
                      
    'ftods_operand':{TABLE_INIT:[('operand_in',SystemTypes.OBJECT,''),
                                  ('value_of',SystemTypes.OBJECT,''),
                                  ('size_of',SystemTypes.OBJECT,''),
                                  ('case_in',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_repositoryobject"
                     },
                      
    'ftods_metadataliteral':{TABLE_INIT:[('ods_literal_value',SystemTypes.STRING,''),
                                         ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_operand"
                     },
                      
    'ftods_const_operand':{TABLE_INIT:[('ods_references',SystemTypes.OBJECT,''),
                                      ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_operand"
                     },
                      
    'ftods_expression':{TABLE_INIT:[('operator',SystemTypes.STRING,''),
                                  ('theoperands',SystemTypes.OBJECT,''),
                                  ],
                     TABLE_ACCESS:METADATA_ACCESS,
                     TABLE_INHERITS:"ftods_operand"
                     },
                      
    }


g_sequences = {'ftods_objid':OBJECT_ACCESS,
               'ftods_repoid':METADATA_ACCESS,
               'ftods_litid':OBJECT_ACCESS,
               'ftods_extentid':OBJECT_ACCESS,
               'ftods_pythonclassid':SYSTEM_ACCESS,
               'ftods_collectionid':SYSTEM_ACCESS
               }
             
             



g_nameMap = {'_cid':'cid',
             '_oid':'oid',
             '_repoId':'repoid',
             '_repoid':'repoid',
             'comment':'ods_comment',
             '_union':'ods_union',
             '_literal_value':'ods_literal_value',
             'references':'ods_reference',
             'index':'ods_index',
             }
            
