#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_clean.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_clean.py.html
#


#A Tool for removing all unaccessible objects from the database (Garbage Collections)

def PrintUsage():
    print "*** 4odb_clean.py"
    print "    Remove all objects from the database that are not accessible from either an extent or a bound name"
    print "    Usage:"
    print "        4odb_clean.py dbName"
    



def Run(argv):
    import sys
    from Ft.Ods.StorageManager.Adapters import g_driverModule

    if len(argv) != 2:
        PrintUsage()
        sys.exit(0)

    dbName = argv[1]
    g_driverModule.CleanDb(dbName)

if __name__ == '__main__':
    import sys
    Run(sys.argv)
    
