#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_clear.py
#
# Author:		Mike Olson
#
# Creation Date:	2000-06-10
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_clear.py.html
#



#A Tool for clearing all data from an existing database.

def PrintUsage():
    print "*** 4odb_clear.py"
    print "    Remove all existing data from a 4ODS database"
    print "    Usage:"
    print "        4odb_clear.py dbName"
    



def Run(argv):
    import sys

    if len(argv) != 2:
        PrintUsage()
        sys.exit(0)


    from Ft.Ods.StorageManager.Adapters import g_driverModule

    dbName = argv[1]
    g_driverModule.ClearDb(dbName)

if __name__ == '__main__':
    import sys
    Run(sys.argv)
