#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_grant.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_grant.py.html
#


#A Tool for granting access to the database for different users

def PrintUsage():
    print "*** 4odb_grant.py"
    print "    Grant access to a 4ODS database."
    print "    Usage:"
    print "        4odb_grant.py dbName level uName1... [uname n]"
    print
    print "          Possible Levels"
    print "          ALL:  All access levels mentioned below"
    print "          METADATA: Access to add, modify and delete Metadata"
    print "          OBJECT:  Access to add, modify and delete Objects (default)"


def Grant(dbName,users,level):

    if level not in ['ALL','METADATA','OBJECT']:
        raise "Unknown level %s" % level

    from Ft.Ods.StorageManager.Adapters import g_driverModule

    for user in users:
        g_driverModule.GrantAccess(dbName,user,level)


def Run(argv):
    import sys
    if len(argv) < 4:
        PrintUsage()
        sys.exit()

    dbName = argv[1]
    level = argv[2]
    users = argv[3:]

    Grant(dbName,users,level)

if __name__ == '__main__':

    import sys
    Run(sys.argv)
