#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_destroy.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_destroy.py.html
#


#Dump a 4ODS database using OIF

def PrintUsage():
    print "*** 4odb_odmsdump.py"
    print "    Dump a 4ODS data base to OIF"
    print "    Usage:"
    print "        4odb_odmsdump.py dbName [outFile name]"
    print
    print "        If outFile name is not specified (or is -) standard out will be used"
    


def Run(argv):
    import sys
    from Ft.Ods import StorageManager
    from Ft.Ods import Database

    outStream = None
    if len(argv) < 2:
        PrintUsage()
        sys.exit()
    elif len(argv) < 3:
        outStream = sys.stdout
    else:
        fileName = sys.argv[2]
        if fileName == '-':
            outStream = sys.stdout
        else:
            outStream = open(fileName,'w')

    dbName = argv[1]

    db = Database.Database()
    db.open(dbName)
    tx = db.new()
    tx.begin()

    s = StorageManager.StorageManager(dbName)

    s._4ods_dumpOif(outStream)

if __name__ == '__main__':
    import sys
    Run(sys.argv)
