#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_odmsload.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_destroy.py.html
#


#Load a 4ODS database from OIF

def PrintUsage():
    print "*** 4odb_odmsload.py"
    print "    Load a 4ODS data base from OIF"
    print "    Usage:"
    print "        4odb_odmsload.py dbName [inFile name]"
    print
    print "        If inFile name is not specified (or is -) standard in will be used"
    


def Run(argv):
    import sys
    from Ft.Ods import StorageManager
    from Ft.Ods import Database



    inStream = None
    if len(argv) < 2:
        PrintUsage()
        sys.exit()
    elif len(argv) < 3:
        inStream = sys.stdin
    else:
        fileName = argv[2]
        if fileName == '-':
            inStream = sys.stdin
        else:
            inStream = open(fileName,'r')

        

    dbName = argv[1]

    db = Database.Database()
    db.open(dbName)
    tx = db.new()
    tx.begin()

    s = StorageManager.StorageManager(dbName)

    s._4ods_loadOif(inStream.read())

    tx.commit()

if __name__ == '__main__':
    import sys
    Run(sys.argv)
