# DOMException
from xml.dom import INDEX_SIZE_ERR, DOMSTRING_SIZE_ERR , HIERARCHY_REQUEST_ERR
from xml.dom import WRONG_DOCUMENT_ERR, INVALID_CHARACTER_ERR, NO_DATA_ALLOWED_ERR
from xml.dom import NO_MODIFICATION_ALLOWED_ERR, NOT_FOUND_ERR, NOT_SUPPORTED_ERR
from xml.dom import INUSE_ATTRIBUTE_ERR, INVALID_STATE_ERR, SYNTAX_ERR
from xml.dom import INVALID_MODIFICATION_ERR, NAMESPACE_ERR, INVALID_ACCESS_ERR

# EventException
from xml.dom import UNSPECIFIED_EVENT_TYPE_ERR

# Fourthought Exceptions
from xml.dom import XML_PARSE_ERR

DOMExceptionStrings = {
    INDEX_SIZE_ERR: "Index error accessing NodeList or NamedNodeMap",
    DOMSTRING_SIZE_ERR: "DOMString exceeds maximum size",
    HIERARCHY_REQUEST_ERR: "Node manipulation results in invalid parent/child relationship.",
    WRONG_DOCUMENT_ERR: "Node is from a different document",
    INVALID_CHARACTER_ERR: "Invalid or illegal character",
    NO_DATA_ALLOWED_ERR: "Node does not support data",
    NO_MODIFICATION_ALLOWED_ERR: "Attempt to modify a read-only object",
    NOT_FOUND_ERR: "Node does not exist in this context",
    NOT_SUPPORTED_ERR: "Object or operation not supported",
    INUSE_ATTRIBUTE_ERR: "Attribute already in use by an element",
    INVALID_STATE_ERR: "Object is not, or is no longer, usable",
    SYNTAX_ERR: "Specified string is invalid or illegal",
    INVALID_MODIFICATION_ERR: "Attempt to modify the type of a node",
    NAMESPACE_ERR: "Invalid or illegal namespace operation",
    INVALID_ACCESS_ERR: "Object does not support this operation or parameter",
    }

EventExceptionStrings = {
    UNSPECIFIED_EVENT_TYPE_ERR : "Uninitialized type in Event object",
    }

FtExceptionStrings = {
    XML_PARSE_ERR : "XML parse error at line %d, column %d: %s",
    }
