########################################################################
#
# File Name:   Boolean.py
#
# Docs:        http://docs.4suite.com/XPATH/Boolean.py.html
#
"""
A container class for boolean expression results.
Should never be seen outside of the XPATH internals.
WWW: http://4suite.com/XPATH        e-mail: support@4suite.com

Copyright (c) 2000 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

intern('true')
intern('false')

def BooleanEvaluate(exp, context):
    rt = exp.evaluate(context)
    if isinstance(rt, BooleanType):
        return rt
    elif type(rt) in [type(1), type(2.3), type(long(3))]:
        return rt == context.position and True or False
    else:
        from xml.xpath.Conversions import BooleanValue
        return BooleanValue(rt)

class BooleanType:
    def __init__(self,val):
        if val == 1 or val == 'true':
            self._val = 1
        elif val == 0 or val == 'false':
            self._val = 0

    def __str__(self):
        return self._val and 'true' or 'false'

    def __int__(self):
        return self._val

    def __and__(self, right):
        return self._val and int(right) and True or False

    def __or__(self, right):
        return (self._val or int(right)) and True or False

    def __nonzero__(self):
        """Allows use of not"""
        return self._val

    def __repr__(self):
        return str(self._val)
    
True = BooleanType(1)
False = BooleanType(0)

def Boolean(val):
    return (val == 1 or val is 'true') and True or False

