from xml.xslt import Error

g_errorMessages = {
    Error.INTERNAL_ERROR: 'There is an internal bug in 4XSLT.  Please report this error code to support@4suite.com: %s',
    Error.PATTERN_SYNTAX: 'Syntax error in pattern at location %s (XPattern production number: %d).',
    Error.PATTERN_SEMANTIC: 'Parse tree error in pattern at location %s (XPattern production number: %d, error type: %s, error value: %s, traceback:\n%s',

    Error.APPLYIMPORTS_WITH_NULL_CURR_TPL: 'apply-imports used where there is no current template.  (see XSLT Spec)',
    Error.ILLEGAL_IMPORT: 'import is not allowed here.  ',
    Error.STYLESHEET_PARSE_ERROR: 'Stylesheet (%s): XML parse error at line %d, column %d: %s',
    Error.SOURCE_PARSE_ERROR: 'Source document (%s): %s',
#    Error.STYLESHEET_PARSE_ERROR: 'Stylesheet(XML) parse exception at line %d, column %d: %s',
#    Error.SOURCE_PARSE_ERROR: 'Source document XML parse exception at line %d, column %d: %s',
    Error.ILLEGAL_CALLTEMPLATE_CHILD: 'call-templates child must be with-param., (see XSLT Spec: 6)',
    Error.ILLEGAL_APPLYTEMPLATE_CHILD: 'apply-templates child must be with-param or sort., (see XSLT Spec: 5.4)',
    Error.WHEN_AFTER_OTHERWISE: 'when cannot succeed otherwise.',
    Error.MULTIPLE_OTHERWISE: 'there cannot be more than one otherwise within a choose.',
    Error.ILLEGAL_CHOOSE_CHILD: 'choose child must be "when" or "otherwise"., (see XSLT Spec: 9.2)',
    Error.CHOOSE_WHEN_AFTER_OTHERWISE: 'choose cannot have "when" child after "otherwise" child., (see XSLT Spec: 9.2)',
    Error.CHOOSE_MULTIPLE_OTHERWISE: 'choose only allowed one "otherwise" child., (see XSLT Spec: 9.2)',
    Error.CHOOSE_REQUIRES_WHEN_CHILD: 'choose must have atleast one "when" child., (see XSLT Spec: 9.2)',
    Error.ILLEGAL_TEXT_CHILD: 'xsl:text cannot have any child elements"., (see XSLT Spec: 7.2)',
    Error.ILLEGAL_ATTRIBUTESET_CHILD: 'attribute-set child must be "attribute"., (see XSLT Spec: 7.1.4)',
    Error.ATTRIBUTESET_REQUIRES_NAME: 'missing attribute-set required attribute name., (see XSLT Spec: 7.1.4)',
    Error.INVALID_FOREACH_SELECT: 'for-each select attribute must evaluate to a node set (see XSLT Spec: 8)',

    Error.VALUEOF_MISSING_SELECT: 'missing value-of requried attribute select (see XSLT Spec: 7.6.1)',
    Error.COPYOF_MISSING_SELECT: 'missing copy-of requried attribute select (see XSLT Spec: 11.3)',
    Error.WHEN_MISSING_TEST: 'missing when requried attribute test (see XSLT Spec: 9.2)',

    Error.TOP_LEVEL_ELEM_WITH_NULL_NS: '',
    Error.XSLT_ILLEGAL_ATTR: 'Illegal attribute "%s" with null namespace in XSLT element "%s" (see XSLT Spec: 2.1).',
    Error.XSLT_ILLEGAL_ELEMENT: 'Illegal Element "%s" in XSLT Namespace (see XSLT Spec: 2.1).',
    Error.STYLESHEET_ILLEGAL_ROOT: 'Illegal Document Root Element "%s" (see XSLT Spec: 2.2).',

    Error.ILLEGAL_SORT_DATA_TYPE_VALUE: 'The "data-type" attribute of sort must be either "text" or "number" (see XSLT Spec: 10).',
    Error.ILLEGAL_SORT_CASE_ORDER_VALUE: 'The "case-order" attribute of sort must be either "upper-first" or "lower-first" (see XSLT Spec: 10)',
    Error.ILLEGAL_SORT_ORDER_VALUE: 'The "order" attribute of sort must be either "ascending" or "descending". (see XSLT Spec: 10)',
    Error.AVT_SYNTAX: 'Syntax error in attribute-value template. (see XSLT Spec: 7.6.2)',
    Error.NO_STYLESHEET: 'No stylesheets to process.',
    Error.STYLESHEET_MISSING_VERSION: 'Style-sheet document root element must have a version attribute.  (see XSLT Spec: 2.2 - 2.3)',
    Error.STYLESHEET_MISSING_VERSION_NOTE1: 'Style-sheet document root element must have a version attribute.  (see XSLT Spec: 2.2 - 2.3).  Note that you do not have the http://www.w3.org/1999/XSL/Transform namespace declared in your top element.',
    Error.ILLEGAL_TEMPLATE_PRIORITY: 'Invalid priority value for template. (see XSLT Spec: 5.5)',

    Error.ILLEGAL_NUMBER_GROUPING_SIZE_VALUE: 'The "grouping-size" attribute of number must be an integer. (see XSLT Spec: 7.7.1)',
    Error.ILLEGAL_NUMBER_LEVEL_VALUE: 'The "level" attribute of number must be "single", "multiple" or "any". (see XSLT Spec: 7.7)',
    Error.ILLEGAL_NUMBER_FORMAT_VALUE: 'Invalid value for "format" attribute of number. (see XSLT Spec: 7.7)',
    Error.ILLEGAL_NUMBER_LETTER_VALUE_VALUE: 'The "letter-value" attribute of number must be "alphabetic" or "traditional". (see XSLT Spec: 7.7.1)',

    Error.INVALID_NAMESPACE_ALIAS: 'Invalid arguments to the namespace-alias instruction. (see XSLT Spec: 7.1.1)',

    Error.WRONG_NUMBER_OF_ARGUMENTS: 'A built-in or extension function was called with the wrong number of arguments.',
    Error.WRONG_ARGUMENT_TYPE: 'A built-in or extension function was called with the wrong number of arguments.',

    Error.FEATURE_NOT_SUPPORTED: '4XSLT does not yet support this feature.',

    Error.INVALID_PATTERN: 'Invalid pattern (%s).',
    Error.INVALID_OPERAND_IN_PATTERN: 'Invalid operand (%s) in pattern.',
    Error.INVALID_OPERAND_ID: 'Invalid operand (%s) for "id".',
    Error.INVALID_OPERAND_IDREL: 'Invalid operand (%s) for "id" with relative path.',
    Error.INVALID_OPERAND_SREL: 'Invalid operand (%s) in absolute location path.',
    Error.INVALID_OPERAND_REL: 'Invalid operand (%s) in relative location path.',
    Error.INVALID_LEFT_OR_RIGHT_OPERAND_S: 'Invalid left or right operand (%s or %s) to "/".',
    Error.INVALID_LEFT_OR_RIGHT_OPERAND_RELP: 'Invalid left or right operand (%s or %s) in relative path.',
    Error.INVALID_AXIS_SPEC: 'Invalid axis specifier',
    Error.INVALID_NODE_TEST: 'Invalid node test',
    Error.INVALID_PREDICATE_LIST: 'Invalid predicate list',

    Error.ATTRIBUTE_ADDED_AFTER_ELEMENT: 'xsl:attribute instantiated within an element instantiation after a child element has been added. (see XSLT Spec: 7.1.3)',
    Error.UNDEFINED_ATTRIBUTE_SET: 'Undefined attribute set (%s)',
    Error.RESTRICTED_OUTPUT_VIOLATION: 'The requested output of element "%s" is forbidden accirding to output restrictions',
    #Error.: '',

    Error.STYLESHEET_REQUESTED_TERMINATION: 'A message instruction in the Stylesheet requested termination of processing:\n%s'
    }

