


from Ft.Ods.StorageManager.Adapters import Constants



def test():
    #Test the collection persistence interface to the DB

    #We will use 2 classes and create the extends interface between them
    #Give one of the classes an extents

    from Ft.Ods.MetaData import Class
    from Ft.Ods import Database

    db = Database.Database()
    db.open('test')


    #Test with no collection access
    print "Test a collection with no access"
    tx = db.new()
    tx.begin()

    c = Class.Class()

    print c
    print c.tupleNames
    print c.tupleTypes
    print c._4ods_getFullTuple()

    tx.commit()

    id = c._4ods_getId()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c


    c.delete()

    tx.commit()
    

    print "Test collection created, no data"
    tx = db.new()
    tx.begin()

    c = Class.Class()

    print c
    print c.extents
    print c.extents._4ods_getContents()
    print c.tupleNames
    print c.tupleTypes
    print c._4ods_getFullTuple()

    tx.commit()   

    id = c._4ods_getId()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c
    print c.extents

    c.delete()

    tx.commit()

    print "Test collection with data"
    tx = db.new()
    tx.begin()

    c = Class.Class()
    c.extents.insert_element("ext")
    c.extents.insert_element("ext1")

    print c
    print c.extents
    print c.extents._4ods_getContents()

    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']

    
    print c.tupleNames
    print c.tupleTypes
    print c._4ods_getFullTuple()

    tx.commit()   

    id = c._4ods_getId()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c
    print c.extents

    print "DBMapping after load"
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']
    

    print "Get the 2nd item"
    print c.extents.retrieve_element_at(1)


    print "After Adding one item"
    c.extents.insert_element('ext2')
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']

    c.extents.remove_element('ext1')
    
    print "After removing one item"
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']

    print c.extents._4ods_getContents()
    tx.commit()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c
    print c.extents

    print "DBMapping after load"
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']
    

    print "*"*100
    print "One more big test with many inserts and removes"

    c.extents.insert_element_before("Begining",0)
    c.extents.insert_element_after("Second",0)

    print c.extents._4ods_getContents()

    tx.commit()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c
    print c.extents

    print "DBMapping after load"
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']
        
    c.extents.remove_element_at(1)
    c.extents.insert_element("End")

    for ctr in range(4):
        print c.extents.retrieve_element_at(ctr)

    print c.extents._4ods_getContents()
    
    tx.commit()

    tx = db.new()
    tx.begin()

    c = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c
    print c.extents

    print "DBMapping after load"
    print c.extents.__dict__['_dbMapping']
    print c.extents.__dict__['_inverseDbMapping']
    print c.extents.__dict__['_values']


    print "*"*100
    print "Form a relationship"
    c2 = Class.Class()
    c3 = Class.Class()

    c3.form_extender(c2)

    print c3.extender
    print "DBMapping before commit"
    print c2.extensions.__dict__['_dbMapping']
    print c2.extensions.__dict__['_inverseDbMapping']
    print c2.extensions.__dict__['_values']    

    tx.commit()

    id = c3._4ods_getId()

    tx = db.new()
    tx.begin()

    c3 = db._4ods_getPersistentObjectById(Constants.ObjectTypes.REPO,id)

    print c3.extender

    c2 = c3.extender

    print "DBMapping after Load"
    print c2.extensions.__dict__['_dbMapping']
    print c2.extensions.__dict__['_inverseDbMapping']
    print c2.extensions.__dict__['_values']    

if __name__ == '__main__':

    import sys
    if len(sys.argv) > 1:
        import os
        os.system('4odb_destroy.py test')
        os.system('4odb_create.py test 1')
    test()


