
from Ft.Ods.Collections import CollectionOfValues
from Ft.Ods.Collections import CollectionOfPersistentObjects
from Ft.Ods.Collections import LiteralCollection
from Ft.Ods.Collections import ListBase
from Ft.Ods.Collections import SetBase
from Ft.Ods.Collections import BagBase

import TestUtil

def test_literal_collection(lc):
    #Nothing to test
    return 1


def test_list_base(lb,fac):

    lb2 = lb.copy()

    values = []
    for ctr in range(6):
        values.append(fac.next())

    print "**Test insert_first**"

    lb.insert_element_first(values[0])

    TestUtil.TestContentLengths(lb,1)

    if lb._4ods_getContents()[0] != values[0]:
        raise "insert element first failed"

    lb.insert_element_first(values[1])

    TestUtil.TestContentLengths(lb,2)

    if lb._4ods_getContents()[0] != values[1]:
        raise "insert element first failed"
    
    print "insert_element_first works"


    print "**Test insert_element_last**"

    lb.insert_element_last(values[2])

    TestUtil.TestContentLengths(lb,3)

    if lb._4ods_getContents()[-1] != values[2]:
        raise "insert element last failed"

    print "**insert element last works**"

    print "**Test insert_element_after**"

    lb.insert_element_after(values[3],1)

    TestUtil.TestContentLengths(lb,4)

    if lb._4ods_getContents()[2] != values[3]:
        raise "insert_element_after failed"

    print "**insert_element_after works**"

    print "**test insert_element_before**"

    lb.insert_element_before(values[4],1)

    TestUtil.TestContentLengths(lb,5)

    if lb._4ods_getContents()[1] != values[4]:
        raise "insert_element_before failed"

    print "**insert_element_before works**"

    print "**Test insert exceptions**"


    from Ft.Ods.Collections.ListBase import ListBase

    try:
        lb.insert_element_after(values[5],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.insert_element_after(values[5],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.insert_element_before(values[5],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.insert_element_before(values[5],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    

    print "**Insert Exceptions work**"

    print "**Test Retrieve_element_at**"

    if lb.retrieve_element_at(1) != values[4]:
        raise "retrieve_element_at failed"

    try:
        lb.retrieve_element_at(-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.retrieve_element_at(10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    print "**Retrieve element at works**"


    print "**TEst retrieve element first**"

    if lb.retrieve_first_element() != values[1]:
        raise "retrieve element first failed"

    print "**retrieve element first works**"

    print "test retrieve element last**"

    if lb.retrieve_last_element() != values[2]:
        raise "retrieve element last failed"

    print "**retrieve element last works**"

    print "**Test replace element**"

    lb.replace_element_at(values[5],1)

    TestUtil.TestContentLengths(lb,5)

    if lb._4ods_getContents()[1] != values[5]:
        raise "replace element at at failed"
    
    try:
        lb.replace_element_at(values[1],-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.replace_element_at(values[1],10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"

    print "**replace element at works**"


    print "**Test remove_element_at**"

    lb.remove_element_at(1)

    TestUtil.TestContentLengths(lb,4)

    if lb.retrieve_element_at(1) == values[5]:
        raise "remove element at failed"

    try:
        lb.remove_element_at(-1)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"
    
    try:
        lb.remove_element_at(10)
    except ListBase.InvalidIndex, e:
        pass
    else:
        raise "Proper exception not raised"

    print "**remove element at works**"
    

    print "**test remove first element**"

    lb.remove_first_element()

    TestUtil.TestContentLengths(lb,3)

    if lb.retrieve_first_element() == values[1]:
        raise "remove first element failed"

    print "**Remove first element works**"

    print "**Test remove last element**"

    lb.remove_last_element()
    
    TestUtil.TestContentLengths(lb,2)

    if lb.retrieve_last_element() == values[2]:
        raise "remove last element failed"

    print "**Remove last element works**"


    lb._4ods_clearContents()

    print "**Test first and last exceptions**"

    from Ft.Ods.Collections import CollectionBase

    try:
        lb.remove_first_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        raise "Proper exception not thrown"

    try:
        lb.remove_last_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        raise "Proper exception not thrown"
    try:
        lb.retrieve_first_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        raise "Proper exception not thrown"

    try:
        lb.retrieve_last_element()
    except CollectionBase.CollectionBase.ElementNotFound, e:
        pass
    else:
        raise "Proper exception not thrown"

    print "**first and last exceptions work**"

    lb2 = lb.copy()

    lb.insert_element(values[0])
    lb2.insert_element(values[1])

    print "**Test concat**"

    rt = lb.concat(lb2)

    TestUtil.TestContentLengths(rt,2)

    if not values[0] in rt._4ods_getContents():
        raise "concat failed"

    if not values[1] in rt._4ods_getContents():
        raise "concat failed"

    print "**concat works**"

    print "**test append**"

    lb.append(lb2)

    TestUtil.TestContentLengths(lb,2)

    if not values[0] in lb._4ods_getContents():
        raise "append failed"

    if not values[1] in lb._4ods_getContents():
        raise "append failed"

    print "**append works**"

    print "**Test is Ordered**"

    if not lb.is_ordered():
        raise "Is Ordered failed"

    print "**Is Ordered works**"

    print "**Test Allows Duplicates **"

    if not lb.allows_duplicates():
        raise "Duplicated allowed failed"

    print "**Allows Duplicates works**"

    print "**Test insert element override**"

    lb._4ods_clearContents()

    lb.insert_element(values[0])

    lb.insert_element(values[1])

    if lb.retrieve_last_element() != values[1]:
        raise "insert_element override failed"

    print "**insert element override worked**"

    print "**Test remove element override**"

    lb.remove_element(values[0])

    TestUtil.TestContentLengths(lb,1)

    if lb.retrieve_first_element() != values[1]:
        raise "remove element override failed"

    print "**remove element override works**"
    
    


def test_set_base(sb,fac):


    sb2 = sb.copy()

    values = []
    for ctr in range(3):
        values.append(fac.next())

    sb.insert_element(values[0])
    sb.insert_element(values[1])

    sb2.insert_element(values[1])
    sb2.insert_element(values[2])

    print "**Test Union**"
    rt = sb.create_union(sb2)

    if len(rt._4ods_getContents()) != 1:
        raise "Invalid length for union"

    if rt._4ods_getContents()[0] != values[1]:
        raise "Wrong item in union"

    print "**Union works**"

    print "**Test Intersection**"

    rt = sb.create_intersection(sb2)

    if len(rt._4ods_getContents()) != 3:
        raise "Invalid Length for intersection"

    if values[0] not in rt._4ods_getContents():
        raise "Not all elements in intersection"
    if values[1] not in rt._4ods_getContents():
        raise "Not all elements in intersection"
    if values[2] not in rt._4ods_getContents():
        raise "Not all elements in intersection"


    print "**Intersection Works**"

    print "**Difference Works**"

    rt = sb.create_difference(sb2)

    if len(rt._4ods_getContents()) != 2:
        raise "Wrong size for difference"

    if values[0] not in rt._4ods_getContents():
        raise "Not all elements in difference"
    if values[2] not in rt._4ods_getContents():
        raise "Not all elements in difference"

    print "**Difference works**"

    print "**Test Subset**"

    union = sb.create_union(sb2)
    inter = sb.create_intersection(sb2)
    diff = sb.create_difference(sb2)

    if sb.is_subset_of(union):
        raise "subset_of failed"

    if not sb.is_subset_of(inter):
        raise "subset_of failed"

    print "**Subset works**"

    print "**Test Proper subset**"

    if sb.is_proper_subset_of(sb):
        raise "Proper subset failed"

    if not sb.is_proper_subset_of(inter):
        raise "Proper subset failed"

    print "**Proper subset works**"

    print "**Test Superset**"

    if not inter.is_superset_of(sb):
        raise "superset_of failed"

    if union.is_superset_of(sb):
        raise "superset_of failed"


    print "**Superset works**"

    print "**TEst proper superset **"

    if sb.is_proper_superset_of(sb):
        raise "Proper super set failed"

    if not inter.is_proper_superset_of(sb):
        raise "Proper super set failed"

    print "**Proper super set works**"


    print "**Test is Ordered**"

    if sb.is_ordered():
        raise "Is Ordered failed"

    print "**Is Ordered works**"

    print "**Test Allows Duplicates **"

    if sb.allows_duplicates():
        raise "Duplicated allowed failed"

    print "**Allows Duplicates works**"

    print "**Test insert element override**"

    sb._4ods_clearContents()

    sb.insert_element(values[0])

    sb.insert_element(values[0])

    if len(sb._4ods_getContents()) != 1:
        raise "Insert element override failed"

    print "**insert element override worked**"



def test_bag_base(bb,fac):

    values = []
    for ctr in range(3):
        values.append(fac.next())


    print "**Test Occurrences_of**"
    if bb.occurrences_of(values[0]) != 0:
        raise "Occurrences_of failed"

    bb.insert_element(values[0])
    
    if bb.occurrences_of(values[0]) != 1:
        raise "Occurrences_of failed"
    
    bb.insert_element(values[0])
    
    if bb.occurrences_of(values[0]) != 2:
        raise "Occurrences_of failed"
    

    print "**Occurrences_of works**"

    print "**Test Union**"
    bb._4ods_clearContents()


    bb2 = bb.copy()
    bb.insert_element(values[0])
    bb.insert_element(values[1])

    bb2.insert_element(values[1])
    bb2.insert_element(values[2])

    print "**Test Union**"
    rt = bb.create_union(bb2)

    if len(rt._4ods_getContents()) != 1:
        raise "Invalid length for union"

    if rt._4ods_getContents()[0] != values[1]:
        raise "Wrong item in union"

    print "**Union works**"

    print "**Test Intersection**"

    rt = bb.create_intersection(bb2)

    if len(rt._4ods_getContents()) != 3:
        raise "Invalid Length for intersection"

    if values[0] not in rt._4ods_getContents():
        raise "Not all elements in intersection"
    if values[1] not in rt._4ods_getContents():
        raise "Not all elements in intersection"
    if values[2] not in rt._4ods_getContents():
        raise "Not all elements in intersection"


    print "**Intersection Works**"

    print "**Test Difference Works**"

    rt = bb.create_difference(bb2)

    if len(rt._4ods_getContents()) != 2:
        raise "Wrong size for difference"

    if values[0] not in rt._4ods_getContents():
        raise "Not all elements in difference"
    if values[2] not in rt._4ods_getContents():
        raise "Not all elements in difference"

    print "**Difference works**"

    print "**Test is_ordered override**"

    if bb.is_ordered():
        raise "is_ordered Failed"

    print "**is_ordered override works**"

    print "**Test allows_duplicates override**"

    if not bb.allows_duplicates():
        raise "allows_duplicates failed"

    print "**allows_duplicates works**"

    print "**Test insert_element and remove_element overrides**"

    bb._4ods_clearContents()

    bb.insert_element(values[0])
    bb.insert_element(values[0])
    bb.remove_element(values[0])

    if bb.occurrences_of(values[0]) != 1:
        raise "remove element failed"

    print "**insert_element and remove_element override works**"



def test_collection_of(cov,fac):

    values = []
    for ctr in range(3):
        values.append(fac.next())

    hasId = hasattr(fac,"nextId")

    internalValues = values

    if hasId:
        internalValues = map(lambda x:x._4ods_getId(),values)


    TestUtil.TestContentLengths(cov,0)

    if cov._4ods_isModified():
        raise "isModified is wrong"

    print "**Test Inserts**"
    cov._4ods_insertElementByIndex(values[0],0)

    TestUtil.TestContentLengths(cov,1)

    if cov._4ods_getContents()[0] != values[0]:
        raise "Value not inserted correctly"

    cov._4ods_insertElementByIndex(values[1],0)

    TestUtil.TestContentLengths(cov,2)
        
    if cov._4ods_getContents()[0] != values[1]:
        raise "Value not inserted correctly"

    cov._4ods_insertElementByIndex(values[2],-1)

    TestUtil.TestContentLengths(cov,3)

    if cov._4ods_getContents()[-1] != values[2]:
        raise "Value not inserted correctly"

    print "**Inserts work**"

    print "**Test getIndex**"

    if cov._4ods_getIndex(values[0]) != 1:
        raise "getIndex failed"

    print "**getIndex works**"

    print "**Test RetrieveElement**"

    if cov._4ods_retrieveElementByIndex(0) != values[1]:
        raise "Get Element failed"
    if cov._4ods_retrieveElementByIndex(1) != values[0]:
        raise "Get Element failed"
    if cov._4ods_retrieveElementByIndex(2) != values[2]:
        raise "Get Element failed"
    if cov._4ods_retrieveElementByIndex(-1) != values[2]:
        raise "Get Element failed"

    print "**Retrieive Element works**"

    print "**Test Remove Element**"

    cov._4ods_removeElementByIndex(-1)

    TestUtil.TestContentLengths(cov,2)

    if cov._4ods_retrieveElementByIndex(-1) != values[0]:
        raise "Remove failed"
    
    cov._4ods_removeElementByIndex(1)

    TestUtil.TestContentLengths(cov,1)

    if cov._4ods_retrieveElementByIndex(0) != values[1]:
        raise "Remove failed"

    cov._4ods_removeElementByIndex(0)

    TestUtil.TestContentLengths(cov,0)

    print "**Remove works**"
    
    print "**Test Clear Contents**"
    cov._4ods_clearContents()

    if cov._4ods_isModified():
        raise "Clear Contents failed"

    TestUtil.TestContentLengths(cov,0)

    print "**Clear Contents works**"


    print "**Test Initialize**"
    cov._4ods_initialize(len(internalValues),"Foo",internalValues)

    if cov._4ods_retrieveElementByIndex(0) != values[0]:
        raise "Initialized failed"
    
    print "**Initialize Works**"

    print "**Test count occurrences**"

    cov._4ods_clearContents()

    if cov._4ods_countOccurrences(values[0]) != 0:
        raise "Count Occurrences failed"

    cov.insert_element(values[0])

    if cov._4ods_countOccurrences(values[0]) != 1:
        raise "Count Occurrences failed"
    print "**Count Occurrences works**"
    

def test_collection_base(cb,fac):
    
    values = []
    for ctr in range(6):
        values.append(fac.next())

    print "**Test cardinality**"
    if cb.cardinality() != 0:
        raise "Cardinality Failed"
    cb.insert_element(values[0])

    if cb.cardinality() != 1:
        raise "Cardinality Failed"

    cb._4ods_clearContents()

    print "**Cardinality Works**"

    print "**Test is_empty**"

    if not cb.is_empty():
        raise "is_empty failed"

    cb.insert_element(values[0])

    if cb.is_empty():
        raise "is_empty Failed"

    print "**is_empty works**"

    print "**Test insert_element, contains_element, and remove_element**"

    cb._4ods_clearContents()

    if cb.contains_element(values[0]):
        raise "containts_element failed"

    cb.insert_element(values[0])

    if not cb.contains_element(values[0]):
        raise "containts_element failed"
    if cb.contains_element(values[1]):
        raise "containts_element failed"

    cb.remove_element(values[0])

    if cb.contains_element(values[0]):
        raise "containts_element failed"

    print "**insert_element, contains_element, and remove_element work**"


    print "**test pythonic interface**"

    cb._4ods_clearContents()

    cb2 = cb.copy()

    if cb != cb2:
        raise "__cmp__ failed"

    cb.insert_element(values[0])
    cb2.insert_element(values[0])

    if cb != cb2:
        raise "__cmp__ failed"

    cb.insert_element(values[1])

    if cb == cb2:
        raise "__cmp__ failed"

    if len(cb) != 2:
        raise "len failed"
    
    if cb2[0] != values[0]:
        raise "__getitem__ failed"

    #cb2[0] = values[2]

    #TestUtil.TestContentLengths(cb2,2)

    #if cb2[0] != values[2]:
    #    raise "__setitem failed"

    #del cb2[0]

    #TestUtil.TestContentLengths(cb2,1)

    #if cb2[0] != values[0]:
    #    raise "__delitem__ failed"

    cb2._4ods_clearContents()

    #cb2[0:2] = values[0:2]

    #TestUtil.TestContentLengths(cb2,2)

    #if cb2[0] != values[0]:
    #    raise "__setslice__ failed"

    #if cb2[1] != values[1]:
    #    raise "__setslice__ failed"


    #if cb2[1:][0] != values[1]:
    #    raise "__getslive failed"


    cb._4ods_clearContents()

    #cb[0] = values[3]
    #cb[1] = values[4]

    #cb2[0:0] = cb

    #TestUtil.TestContentLengths(cb2,4)
    
    #if cb2[0] != values[3]:
    #    raise "__setslice failed"

    #del cb2[:2]

    #TestUtil.TestContentLengths(cb2,2)
    
    #if cb2[0] != values[0]:
    #    raise "__setslice failed"


    #cb2._4ods_clearContents()


    #cb2.insert_element(values[0])

    #rt = cb + cb2

    #TestUtil.TestContentLengths(rt,3)

    #if rt[0] != values[3]:
    #    raise "__add__ failed"

    #if rt[-1] != values[0]:
    #    raise "__add__ failed"

    #rt = rt + values[-2:]

    #TestUtil.TestContentLengths(rt,5)

    #if rt[-1] != values[5]:
    #    raise "__add__ failed"


    #cb._4ods_clearContents()

    #cb.insert_element(values[0])

    #cb = cb * 2

    #TestUtil.TestContentLengths(cb,2)

    #if cb[0] != values[0]:
    #    raise "__mul__ failed"

    #if cb[1] != values[0]:
    #    raise "__mul__ failed"


    #cb.append(values[1])

    #TestUtil.TestContentLengths(cb,3)

    #if cb[-1] != values[1]:
    #    raise "append failed"

    #cb.insert(1,values[2])

    #TestUtil.TestContentLengths(cb,4)

    #if cb[1] != values[2]:
    #    raise "insert failed"

    #if cb.pop(1) != values[2]:
    #    raise "pop failed"

    #cb.remove(values[1])

    #TestUtil.TestContentLengths(cb,3)

    #if cb[0] != values[0]:
    #    raise "remove failed"

    #if cb.count(values[2]) != 1:
    #    raise "count failed"


    #if cb.index(values[2]) != 1:
    #    raise "index failed"

    #cb._4ods_clearContents()

    #cb[0:0] = values

    #cb.reverse()

    #if cb[0] != values[5]:
    #    raise "reverse failed"

    #if cb[-1] != values[0]:
    #    raise "reverse failed"

    #def compare(left,right):
    #    if type(left) == type(''):
    #        return cmp(left,right)
    #    else:
    #        return cmp(left.name,right.name)

    #cb._4ods_clearContents()

    #cb[0] = values[1]
    #cb[1] = values[0]

    #cb.sort(compare)

    #if cb[0] != values[0]:
    #    raise "sort failed"
    
    #cb._4ods_clearContents()
    #cb2._4ods_clearContents()

    #cb[0] = values[0]
    #cb2[0] = values[1]

    #cb.extend(cb2)

    #TestUtil.TestContentLengths(cb,2)

    #if cb[1] != values[1]:
    #    raise "extend failed"

    #cb.extend(values[2:3])

    #TestUtil.TestContentLengths(cb,3)

    #if cb[-1] != values[2]:
    #    raise "extend failed"


    print "**pythonic interface works**"


class LiteralFactory:
    def __init__(self):
        self.ctr = -1
    def next(self):
        self.ctr = self.ctr + 1
        return "TEXT%d"%self.ctr

    def reset(self):
        self.ctr = -1

class RepoFactory:
    def __init__(self):
        self.objNames = ['pk_boolean','pk_long','pk_short','pk_string','pk_ulong','pk_ushort']
        self.ctr = 0
    def next(self):
        from Ft.Ods import Database
        db = Database.Database()
        obj = db.schema().resolve(self.objNames[self.ctr])
        self.ctr = self.ctr + 1
        return obj

    def nextId(self):
        return self.next()._4ods_getId()

    def reset(self):
        self.ctr = 0


def test_collection(inst):

    litFac = LiteralFactory()
    repoFac = RepoFactory()

    curFac = None

    if isinstance(inst,CollectionOfPersistentObjects.CollectionOfPersistentObjects):
        test_collection_of(inst,repoFac)
        curFac = repoFac
    elif isinstance(inst,CollectionOfValues.CollectionOfValues):
        test_collection_of(inst,litFac)
        curFac = litFac
    else:
        raise "Unknwon Collection Of Type %s" % str(inst)

    inst._4ods_clearContents()
    curFac.reset()

    if isinstance(inst,ListBase.ListBase):
        test_list_base(inst,curFac)
    elif isinstance(inst,SetBase.SetBase):
        test_set_base(inst,curFac)
    elif isinstance(inst,BagBase.BagBase):
        test_bag_base(inst,curFac)
    else:
        raise "Unknwon Collection Type %s" % str(inst)
    
    inst._4ods_clearContents()
    curFac.reset()

    if isinstance(inst,LiteralCollection.LiteralCollection):
        test_literal_collection(inst)
    else:
        raise "Unknwon Collection Persistent Type %s" % str(inst)

    inst._4ods_clearContents()
    curFac.reset()

    test_collection_base(inst,curFac)



from Ft.Ods.MetaData import PrimitiveType
def test():

    #Test all of the colelctions in one big test!

    collections = {'LiteralListOfValues' : (type(""),),
                   'LiteralBagOfValues' : (type(""),),
                   'LiteralSetOfValues' : (type(""),),
                   #'LiteralListOfObjects' : (type(""),),
                   #'LiteralSetOfObjects' : (type(""),),
                   #'LiteralBagOfObjects' : (type(""),),
                   'LiteralListOfRepositoryObjects' : (PrimitiveType.PrimitiveType,),
                   'LiteralSetOfRepositoryObjects' : (PrimitiveType.PrimitiveType,),
                   'LiteralBagOfRepositoryObjects' : (PrimitiveType.PrimitiveType,),
                   }

    from Ft.Ods import Database
    db = Database.Database()
    db.open('test')
    tx = db.new()

    tx.begin()

    for coll in collections.keys():
        print "*"*10 + "Test %s" % coll + "*"*10
        m = __import__("Ft.Ods.Collections.%s" % coll).Ods.Collections
        m = getattr(m,coll)
        c = getattr(m,coll)
        i = c()
        test_collection(i)

    
    tx.abort()


if __name__ == '__main__':

    test()
