



def test():

    from Ft.Ods import Database
    from Ft.Ods.MetaData import Class
    from Ft.Ods.Collections import LiteralListOfRepositoryObjects

    from Ft.Ods.StorageManager.Adapters import Constants

 
    db = Database.Database()
    db.open('test')
    tx = db.new()
    tx.begin()
    top = db.schema().resolve('ODLTypes')

    c1 = top.add_class('C1',None,None)

    c1.keys.insert_element('Key-1')
    c1.extents.insert_element('Extent-1')
    
    
    print c1
    print c1.tupleNames
    print c1.tupleTypes
    print c1._4ods_getFullTuple()
    print c1._4ods_getModifiedTuple()


    l = LiteralListOfRepositoryObjects.LiteralListOfRepositoryObjects(Class.Class)
    l.insert_element(c1)

    
    c2 = top.add_class('Inherits',l,None)
    
    print "***State of Top****"
    print c1
    print c1.tupleNames
    print c1.tupleTypes
    print c1._4ods_getFullTuple()
    print c1._4ods_getModifiedTuple()

    print "***State of Derives****"
    print c2
    print c2.tupleNames
    print c2.tupleTypes
    print c2._4ods_getFullTuple()
    print c2._4ods_getModifiedTuple()

    c3 = top.add_class('Extender',l,c2)

    print "***State of Derives****"
    print c2
    print c2.tupleNames
    print c2.tupleTypes
    print c2._4ods_getFullTuple()
    print c2._4ods_getModifiedTuple()

    print "***State of Extends****"
    print c3
    print c3.tupleNames
    print c3.tupleTypes
    print c3._4ods_getFullTuple()
    print c3._4ods_getModifiedTuple()


    print top._4ods_getOdl()


    tx.commit()


    id = c1._4ods_getRepositoryId()
    id2 = c2._4ods_getRepositoryId()
    id3 = c3._4ods_getRepositoryId()

    tx = db.new()
    tx.begin()

    print "Start second transactions"
    c1 = db._4ods_getPersistentObjectById(Constants.REPO,id)
    c2 = db._4ods_getPersistentObjectById(Constants.REPO,id2)

    print c1
    print c1.name

    print c1._4ods_getOdl()
    print c1._4ods_getOdl()

    tx.commit()

    tx = db.new()
    tx.begin()

    print "Start third transactions"
    c3 = db._4ods_getPersistentObjectById(Constants.REPO,id3)

    c3.delete()
    print db.lookup('ftods_types')._4ods_getContents()

    tx.commit()


    db.close()

if __name__ == '__main__':
    test()
