

import os

tests = ['basic_test1',
         'relationship_test',
         'constants_test',
         'enumeration_test',
         'extent_test',
         'binding_test',
         'types_test',
         'file_test',
         'collections_test',
         'collections_test2',
         'object_attribute_test',
         'copy_test',
]


from Ft.Ods.StorageManager import Adapters
if Adapters.g_driverName != 'Dbm':
    tests.extend(['circular_reference_test',
                  'memory_test',
                  'leave_join_test',
                  'mthread_test',
                  ])


from Ft.Ods import Database
import time

def test(tester,name=None):

    global tests
    db = Database.Database()
    failed = []
    if name:
        tests = [name]

    tests.sort()
    start = time.time()
    for test in tests:
        if 1:
        #try:
            ts =time.time()
            mod = __import__(test)
            mod.test(tester)
            print "%s Completed in %f" % (test,time.time() - ts)
        #except:
        #    failed.append(test)
    end = time.time()
    print "*"*40
    print "Total test time : %f" % (end - start)

    if failed:
        sys.stderr.write("The following tests failed\n")        
    for f in failed:
        sys.stderr.write("\t%s\n"%f)        
        

if __name__ == '__main__':

    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1, 1)

    import sys
    if len(sys.argv) == 2:
        test(tester,sys.argv[1])
    else:

        test(tester)
