#!/usr/bin/env python
#
# File Name:        File Name
#
# Documentation:    http://docs.fourthought.com/file/name.html
#


def test():

    import sys
    from xml.xpath import ParsedExpr
    import DomTree, DummyExpr
    from xml.xpath import XPath


    dummyBoolTrue = DummyExpr.DummyBooleanExpr(1)
    dummyBoolFalse = DummyExpr.DummyBooleanExpr(0)

    dummyNum3 = DummyExpr.DummyNumberExpr(3)
    dummyNumn4 = DummyExpr.DummyNumberExpr(-4)
    dummyNum4p5 = DummyExpr.DummyNumberExpr(4.5)
    
    dummyNodeSet1 = DummyExpr.DummyNodeSetExpr([DomTree.ROOT])
    dummyNodeSet2 = DummyExpr.DummyNodeSetExpr([DomTree.ROOT,DomTree.CHILD1])
    dummyNodeSet3 = DummyExpr.DummyNodeSetExpr([DomTree.CHILD1])

    dummyPiString = DummyExpr.DummyStringExpr('3.14')
    dummyTextString = DummyExpr.DummyStringExpr('Hi')
    
    print "Test Relational"
    p = ParsedExpr.ParsedRelationalExpr(XPath.LESS_THAN,dummyPiString,dummyNumn4)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedRelationalExpr(XPath.GREATER_THAN,dummyPiString,dummyNumn4)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedRelationalExpr(XPath.GREATER_THAN_EQUAL,dummyPiString,dummyPiString)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedRelationalExpr(XPath.LESS_THAN_EQUAL,dummyPiString,dummyNumn4)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)


    print "Test Equality"
    p = ParsedExpr.ParsedEqualityExpr('=',dummyPiString,dummyPiString)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedEqualityExpr('=',dummyPiString,dummyNumn4)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedEqualityExpr(XPath.NOT_EQUAL,dummyPiString,dummyNumn4)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    print "Test And"
    p = ParsedExpr.ParsedAndExpr(dummyBoolTrue,dummyBoolFalse)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedAndExpr(dummyBoolTrue,dummyBoolTrue)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedAndExpr(dummyBoolFalse,dummyBoolFalse)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    print "Test Or"
    p = ParsedExpr.ParsedOrExpr(dummyBoolTrue,dummyBoolFalse)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedOrExpr(dummyBoolTrue,dummyBoolTrue)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)

    p = ParsedExpr.ParsedOrExpr(dummyBoolFalse,dummyBoolFalse)
    p.dump(sys.stdout)
    print
    print p.evaluate(None)



if __name__ == '__main__':
    test()
