

def test():

    import sys
    from xml.xpath import XPath
    from xml.xpath import ParsedExpr
    import DummyExpr, DomTree
    from xml.xpath import Context
    from xml.xpath import CoreFunctions
    from xml.xpath import Conversions
    from xml.xpath import NamespaceNode
    from xml.xpath import Boolean
    
    context1 = Context.Context(DomTree.CHILD1,1,3)
    context2 = Context.Context(DomTree.CHILD2,2,3)

    dummyBoolTrue = DummyExpr.DummyBooleanExpr(1)
    dummyBoolFalse = DummyExpr.DummyBooleanExpr(0)

    dummyNum1 = DummyExpr.DummyNumberExpr(1)
    dummyNum3 = DummyExpr.DummyNumberExpr(3)
    dummyNumn4 = DummyExpr.DummyNumberExpr(-4)
    dummyNum4p5 = DummyExpr.DummyNumberExpr(4.5)
    
    dummyNodeSet0 = DummyExpr.DummyNodeSetExpr([])
    dummyNodeSet1 = DummyExpr.DummyNodeSetExpr([DomTree.ROOT])
    dummyNodeSet2 = DummyExpr.DummyNodeSetExpr([DomTree.ROOT,DomTree.CHILD1])
    dummyNodeSet3 = DummyExpr.DummyNodeSetExpr([DomTree.CHILD1])
    dummyNodeSet4 = DummyExpr.DummyNodeSetExpr([DomTree.CHILD3])

    dummyPiString = DummyExpr.DummyStringExpr('3.14')
    dummyTextString = DummyExpr.DummyStringExpr('Hi')
    dummyPiTextString = DummyExpr.DummyStringExpr('3.14Hi')
    dummySpaceString = DummyExpr.DummyStringExpr('Ht    \t There\t   Mike')

    print "Last"
    p = ParsedExpr.ParsedFunctionCallExpr('last',[])
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)
    print p.evaluate(context2)


    print "Position"
    p = ParsedExpr.ParsedFunctionCallExpr('position',[])
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)
    print p.evaluate(context2)


    print "Count"
    al = [dummyNodeSet2]
    p = ParsedExpr.ParsedFunctionCallExpr('count',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "ID"
    print "Number"
    al = [dummyNum1]
    p = ParsedExpr.ParsedFunctionCallExpr('id',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    DomTree.PrintList(rt)


    print "ExpandedName"
    print "Dom", DomTree.DOM
    print CoreFunctions.ExpandedName(DomTree.DOM)
    print "root", DomTree.ROOT
    rt = CoreFunctions.ExpandedName(DomTree.ROOT)
    print rt
    print rt.namespaceURI
    print rt.localName

    print "element", DomTree.CHILD3
    rt = CoreFunctions.ExpandedName(DomTree.CHILD3)
    print rt
    print rt.namespaceURI
    print rt.localName

    print "attribute", DomTree.ATTR2
    rt = CoreFunctions.ExpandedName(DomTree.ATTR2)
    print rt
    print rt.namespaceURI
    print rt.localName

    print "Namespace", NamespaceNode.NamespaceNode(DomTree.CHILD3.prefix, DomTree.CHILD3.namespaceURI)
    rt = CoreFunctions.ExpandedName(NamespaceNode.NamespaceNode(DomTree.CHILD3.prefix, DomTree.CHILD3.namespaceURI))
    print rt
    print rt.namespaceURI
    print rt.localName

    print "PI", DomTree.PI
    rt = CoreFunctions.ExpandedName(DomTree.PI)
    print rt
    print rt.namespaceURI
    print rt.localName

    print "Comment", DomTree.COMMENT
    rt = CoreFunctions.ExpandedName(DomTree.COMMENT)
    print rt

    print "Text", DomTree.TEXT1
    rt = CoreFunctions.ExpandedName(DomTree.TEXT1)
    print rt


    print "Local-Name"
    print "No NodeSet"
    al = [dummyNodeSet0]
    p = ParsedExpr.ParsedFunctionCallExpr('local-name',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    print "Local-Name"
    print "NodeSet"
    al = [dummyNodeSet4]
    p = ParsedExpr.ParsedFunctionCallExpr('local-name',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    

    print "Namespace-Uri"
    print "No NodeSet"
    al = [dummyNodeSet0]
    p = ParsedExpr.ParsedFunctionCallExpr('namespace-uri',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    print "Namespace-Uri"
    print "NodeSet"
    al = [dummyNodeSet4]
    p = ParsedExpr.ParsedFunctionCallExpr('namespace-uri',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    
    print "Name"
    print "NodeSet"
    al = [dummyNodeSet4]
    p = ParsedExpr.ParsedFunctionCallExpr('name',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    

    print "Test String Function"
    print "Dom"
    print Conversions.StringValue(DomTree.DOM)


    print "root"
    print Conversions.StringValue(DomTree.ROOT)

    print "element"
    print Conversions.StringValue(DomTree.CHILD3)

    print "attribute"
    print Conversions.StringValue(DomTree.ATTR2)

    print "Namespace"
    print Conversions.StringValue(NamespaceNode.NamespaceNode(DomTree.CHILD3.prefix, DomTree.CHILD3.namespaceURI))

    print "PI"
    print Conversions.StringValue(DomTree.PI)

    print "Comment"
    print Conversions.StringValue(DomTree.COMMENT)

    print "Text"
    print Conversions.StringValue(DomTree.TEXT1)

    print "String"
    print "element"
    al = [dummyNodeSet3]
    p = ParsedExpr.ParsedFunctionCallExpr('string',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Concat"
    al = [dummyNodeSet3, dummyPiString, dummyTextString]
    p = ParsedExpr.ParsedFunctionCallExpr('concat',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Starts With "
    print "No"
    al = [dummyNodeSet3, dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('starts-with',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Starts With "
    print "Yes"
    al = [dummyNodeSet3, dummyNodeSet3]
    p = ParsedExpr.ParsedFunctionCallExpr('starts-with',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Contains"
    print "No"
    al = [dummyNodeSet3, dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('contains',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Contains"
    print "Yes"
    al = [dummyNodeSet3, dummyNodeSet3]
    p = ParsedExpr.ParsedFunctionCallExpr('contains',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Substring-before"
    al = [dummyPiTextString, dummyTextString]
    p = ParsedExpr.ParsedFunctionCallExpr('substring-before',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Substring-after"
    al = [dummyPiTextString, dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('substring-after',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Substring"
    print "2 args"
    al = [dummyPiTextString, dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('substring',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Substring"
    print "3 args"
    al = [dummyPiTextString, dummyPiString, dummyNum1]
    p = ParsedExpr.ParsedFunctionCallExpr('substring',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "String-length"
    al = [dummyPiTextString]
    p = ParsedExpr.ParsedFunctionCallExpr('string-length',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Normalize"
    al = [dummySpaceString]
    p = ParsedExpr.ParsedFunctionCallExpr('normalize-space',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    fro = DummyExpr.DummyStringExpr('abcdefg')
    to = DummyExpr.DummyStringExpr('ABCDEFG')
    print "Translate"
    al = [dummySpaceString, fro, to]
    p = ParsedExpr.ParsedFunctionCallExpr('translate',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


    print "Test Boolean"
    print "Boolean"
    print Conversions.BooleanValue(Boolean.Boolean(1))

    print "Number"
    print Conversions.BooleanValue(1)

    print "Number"
    print Conversions.BooleanValue(0)

    print "String"
    print Conversions.BooleanValue("Mike")
    print "String"
    print Conversions.BooleanValue("")

    print "NodeList"
    print Conversions.BooleanValue([])
    print "NodeList"
    print Conversions.BooleanValue(["Mike"])

    print "Other"
    print Conversions.BooleanValue(DomTree.CHILD1)

    print "Boolean"
    al = [dummyPiTextString]
    p = ParsedExpr.ParsedFunctionCallExpr('boolean',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Not"
    al = [dummyPiTextString]
    p = ParsedExpr.ParsedFunctionCallExpr('not',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "True"
    p = ParsedExpr.ParsedFunctionCallExpr('true',[])
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "False"
    p = ParsedExpr.ParsedFunctionCallExpr('false',[])
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt



    print "Test Number"
    print Conversions.NumberValue(2)

    print "String"
    print Conversions.NumberValue("3.14")

    print "Node"
    print Conversions.NumberValue(DomTree.CHILD1)

    print "Number"
    p = ParsedExpr.ParsedFunctionCallExpr('number',[])
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt
    

    #FIXME Test Sum


    print "Floor"
    al = [dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('floor',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Ceiling"
    al = [dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('ceiling',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt

    print "Round"
    al = [dummyPiString]
    p = ParsedExpr.ParsedFunctionCallExpr('round',al)
    p.dump(sys.stdout)
    print
    rt = p.evaluate(context1)
    print rt


if __name__ == '__main__':
    test()
