#!/usr/bin/env python
#
# File Name:        File Name
#
# Documentation:    http://docs.fourthought.com/file/name.html
#


def test():

    import sys
    from xml.xpath import ParsedExpr
    import DomTree, DummyExpr
    from xml.xpath import XPath



    dummyBoolTrue = DummyExpr.DummyBooleanExpr(1)
    dummyBoolFalse = DummyExpr.DummyBooleanExpr(0)

    dummyNum3 = DummyExpr.DummyNumberExpr(3)
    dummyNumn4 = DummyExpr.DummyNumberExpr(-4)
    dummyNum4p5 = DummyExpr.DummyNumberExpr(4.5)
    
    dummy1NodeSet = DummyExpr.DummyNodeSetExpr([DomTree.ROOT])
    dummy2NodeSet = DummyExpr.DummyNodeSetExpr([DomTree.ROOT,DomTree.GCHILD12])

    dummyPiString = DummyExpr.DummyStringExpr('3.14')
    dummyTextString = DummyExpr.DummyStringExpr('Hi')

    from xml.xpath import Context
    context1 = Context.Context(DomTree.CHILD1,1,2)
    context2 = Context.Context(DomTree.CHILD2,2,2)

    
    print "Filter"
    p = ParsedExpr.ParsedFilterExpr(dummy2NodeSet,dummyBoolTrue)
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)

    p = ParsedExpr.ParsedFilterExpr(dummy2NodeSet,dummyBoolFalse)
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)


    print "Path"
    p = ParsedExpr.ParsedPathExpr('/',dummy2NodeSet,dummy1NodeSet)
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)

    #FIXME Test Path //

    print "Union"
    p = ParsedExpr.ParsedUnionExpr(dummy2NodeSet,dummy1NodeSet)
    p.dump(sys.stdout)
    print
    print p.evaluate(context1)    


if __name__ == '__main__':
    test()
